import java.util.ArrayList;


public class ProducerConsumer {
	
	public static void main (String args[]){
		Basket basket = new Basket();
		Producer p1 = new Producer(basket,1);
		Producer p2 = new Producer(basket,2);
		Producer p3 = new Producer(basket,3);
		new Thread(p1).start();
		new Thread(p2).start();
		new Thread(p3).start();
		Consumer c1 = new Consumer(basket, 1);
		Consumer c2 = new Consumer(basket, 2);
		new Thread(c1).start();
		new Thread(c2).start();
	}
}

class Bread{
	int id;
	Bread(int id){
		this.id = id;
	}
	@Override
	public String toString(){
		return "Ʒ:  bread"+id;
	}
}

class Basket{
	Bread[] breads = new Bread[10];
	public int breadNum  = 0;
	
	
	public synchronized void  push(Bread bread){
		if (breadNum == breads.length){
			try {
				this.wait();
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
		breads[breadNum] = bread;
		breadNum++;
		try {
			Thread.sleep(300);
		} catch (InterruptedException e) {
			e.printStackTrace();
		} this.notify();
	}
	
	public synchronized Bread pop(){
		if(breadNum == 0) {
			try {
				this.wait();
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
		this.notifyAll();
		breadNum--;
		Bread bread = breads[breadNum];
		try {
			Thread.sleep(1000);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		return bread;
	}
	
}

class Producer implements Runnable{
	private Basket al = null;
	private int id;
	
	public Producer(Basket al, int id) {
		this.al = al;
		this.id = id;
	}
	
	public void produce(){
		for(int i=0; i<15;i++){
			Bread b = new Bread(i);
			al.push(b);
			System.out.println(this +" has produced-----" + b);
		}
	}

	
	@Override
	public void run() {
		produce();
	}
	
	@Override
	public String toString(){
		return ": " + id;
	}
}

class Consumer implements Runnable{
	private Basket al = null;
	private int id ;
	
	public Consumer(Basket al, int id) {
		this.al = al;
		this.id = id;
	}
	@Override
	public void run() {
		consume();
	}
	private void consume() {
		for(int i=0;i<10;i++){
			Bread b = al.pop();
			System.out.println(this + " has consumed-----" + b);
		}
	}
	@Override
	public String toString(){
		return ": " + id;
	}
}